﻿using System;
using System.Collections.Generic; 
using System.Text; 
using PCBI.Plugin; 
using PCBI.Plugin.Interfaces; 
using PCBI.Automation; 
   
namespace ClassLibraryExample
{
    [Plugin("RibbonDemo", "Demo", "Demo to show how to add to PCB-Investigator Ribbon menu.", "1.0.0.0")]
    public class ClassPCBIConnection: IPluginRibbonCommand
    {

        #region IPluginToolStrip Members
        //On which position should the toolbar dock. 
        private ContainerPosition position = ContainerPosition.Left;
        public ContainerPosition Position
        {
            get
            {
                return position;
            }
            set
            {
                position = value;
            }
        }
        #endregion

        #region IPlugin Members
        //interface information 
        private bool pluginEnabled;
        public bool PluginEnabled
        {
            get
            {
                return pluginEnabled;
            }
            set
            {
                pluginEnabled = value;
            }
        }
        private string assembly;
        public string Assembly
        {
            get
            {
                return assembly;
            }
            set
            {
                assembly = value;
            }
        }
        private string path;
        public string Path
        {
            get
            {
                return path;
            }
            set
            {
                path = Path;
            }
        }
        private Type type;
        public Type Type
        {
            get
            {
                return type;
            }
            set
            {
                type = value;
            }
        }
        IPCBIWindow parent;
        public IPCBIWindow Parent
        {
            get
            {
                return parent;
            }
            set
            {
                parent = value;
            }
        }
        private PluginDestinationWindow pluginDestination = PluginDestinationWindow.MainWindow;
        public PluginDestinationWindow PluginDestination
        {
            get
            {
                return pluginDestination;
            }
            set
            {
                pluginDestination = value;
            }
        }
        public bool IsActionAllowed(ID_ActionItem action)
        {
            return false;
        }
        public void InitEvents(IPCBIWindow Parent)
        {
        }
        #endregion 

        #region ribbon
        int registerEntryPCBI = -1;
        
        public void OnCommandExecute(int cmdID)
        {
            if (cmdID == registerEntryPCBI)
            {
                try
                {
                    UsedScriptToStart.Excecute(parent);
                }
                catch (Exception exceptionInScript)
                {
                    //do error handling

                }
            }
        }

        public void RegisterCommand()
        {
            UsedScriptToStart = new ClassScript();

            registerEntryPCBI = Parent.UIAction.RegisterID(new IRegisterItem()
            {
                Category = "Demo",
                EnableOn = Availability.Always,
                GUID = "MustBeUnique!_" + UsedScriptToStart.NameOfPlugIn,
                RegisterType = RegisterItemType.BUTTON,
                Text = UsedScriptToStart.TextOnButton
            });


        }

        #endregion

        ClassScript UsedScriptToStart = null;
    }
}
